<?php

/* ++++++++++++++++++  xferlog functions   ++++++++++++++++++++++++++++ */

function readlog($XFERLOG_FILE="",$SITE_ROOT=""){
	/* Reads logfile and inserts data into the database
	   Old data is deleted from database before new data is added
	*/
	
	if(strlen($XFERLOG_FILE)<2) $XFERLOG_FILE="/glftpd/ftp-data/logs/xferlog";
	if(strlen($SITE_ROOT)<2) $SITE_ROOT="/site";
	
	$xferlog_file=$XFERLOG_FILE;
	$site_root=$SITE_ROOT;
	// site_root - will be removed from filename
	
	$fd = fopen ($xferlog_file,"r");	// full path to xferlog
	if(!$fd){
		echo "<b>Error reading file!</b><br />\n";
		exit;
	}
	$res=mysql_query("delete from log") or die(mysql_error()); //clears out old log entries
	$num_lines=0;
	$elements=array();
	
	while (TRUE) {
		$buffer = fgets($fd, 4096);
	        $elements=preg_split("/[\s]+/",$buffer);	// split by 1 or more whitespaces
		if($elements[0]=='') break;	// not a nice way to do it, but i works ;-)
	        $timestring=$elements[3]." ".$elements[2]." ". $elements[1]." ". $elements[4];	// create timestring
	        if($elements[9]=="b") $mode=1;	// binary: mode = 1
	        else $mode=0;				// asci: mode = 0
	        if($elements[11]=="o") $direction=1;	// download = 1
	        else $direction=0;			// upload = 0
		$res=mysql_query("insert into log (time,transfertime,host,bytes,file,mode,direction,user,pgroup) values(".date('YmdHis',strtotime($timestring)).",".$elements[5].",'".$elements[6]."',".$elements[7].",'".addslashes(str_replace('?',' ',str_replace($site_root,'',$elements[8])))."',$mode,$direction,'".$elements[13]."','".$elements[14]."')") or die(mysql_error());	// insert log data to database
		$num_lines+=1;
	}
	fclose ($fd);
	$res=mysql_query("insert into stats (lastupdate,numlines) values(".date('YmdHis').",$num_lines)") or die(mysql_error());	// add some stats
}



function lastupdate(){
	$res_update=mysql_query("select UNIX_TIMESTAMP(lastupdate),numlines from stats order by lastupdate desc limit 1") or die(mysql_error());
	$row_update=mysql_fetch_array($res_update);
	$update=array();
	$update[0]=$row_update[0];
	$update[1]=$row_update[1];
	return $update;
}


function usertransfer($user){
	/* Returns users transfer stats in MB */
	$transfer=array();
	$res=mysql_query("select SUM(bytes) from log where user='$user' and direction=0") or die(mysql_error());	// sum of bytes uploaded
        $row=mysql_fetch_array($res);
	$transfer[0]=round($row[0]/1048576,2);
        $res=mysql_query("select SUM(bytes) from log where user='$user' and direction=1") or die(mysql_error());	// sum of bytes downloaded
        $row=mysql_fetch_array($res);
	$transfer[1]=round($row[0]/1048576,2);
	return $transfer;
}


function top10bytes($direction,$limit=10){
	/* Writes top transfer user/number of bytes (in MB) 
	   direction: 0 = upload, 1 = download
	*/
	if($direction==0) echo "<b>Top $limit <span style=\"color: green\">upload</span> [bytes]</b>\n";
	else echo "<b>Top $limit <span style=\"color: red\">download</span> [bytes]</b>\n";
	echo "<div class=\"box-border\">\n";
	echo "<div class=\"box-text\">\n";
	$top10=array();
	$res_top10=mysql_query("select SUM(bytes) as sum,user from log where direction=$direction GROUP by user order by sum desc limit $limit") or die(mysql_error());
	$num_rows=mysql_num_rows($res_top10);
	for($i=0;$i<$num_rows;$i++){
	        $row_top10=mysql_fetch_array($res_top10);
	        $top10[$i][0]=$row_top10[0]; // 0 = sum of uploads 
	        $top10[$i][1]=$row_top10[1]; // 1 = user
	}
	rsort($top10);
	if($num_rows>$limit) $num_rows=($limit);
	for($i=0;$i<$num_rows;$i++){
	        echo "".round($top10[$i][0]/1048576,2)." MB &nbsp;-&nbsp; ".$top10[$i][1]."<br />\n";
	}
	echo "</div>\n</div>\n";
}

function top10files($direction,$limit=10){
	/* Writes top transfer user/number of files
	   direction: 0 = upload, 1 = download
	*/
        if($direction==0) echo "<b>Top $limit <span style=\"color: green\">upload</span> [files]</b>\n";
        else echo "<b>Top $limit <span style=\"color: red\">download</span> [files]</b>\n";
        echo "<div class=\"box-border\">\n";
        echo "<div class=\"box-text\">\n";
	$top10=array();
	$res_top10=mysql_query("select COUNT(user) as cnt,user from log where direction=$direction GROUP by user order by cnt desc limit $limit") or die(mysql_error());
	for($i=0;$i<$limit;$i++){
		$row_top10=mysql_fetch_array($res_top10);
		$top10[$i][0]=$row_top10[0]; // 0 = number of files
		$top10[$i][1]=$row_top10[1]; // 1 = user
	}
	rsort($top10);
        for($i=0;$i<$limit;$i++){
                echo "".$top10[$i][0]." files &nbsp;-&nbsp; ".$top10[$i][1]."<br />\n";
        }
        echo "</div>\n</div>\n";
}

function latest_files($direction,$user="",$limit=10){
	/* Writes the latest log entries
	   direction: 0 = upload, 1 = download
	   If user is set, users stats are displayed
	*/
	if(strlen($user)>1) $query_string="select UNIX_TIMESTAMP(time),file,bytes,user,host from log where direction=$direction and user='$user' order by time desc limit $limit";
	else $query_string="select UNIX_TIMESTAMP(time),file,bytes,user,host from log where direction=$direction order by time desc limit $limit";
	$res_latest=mysql_query($query_string) or die(mysql_error());
	$num_files=mysql_num_rows($res_latest);
	if($num_files>0){
		if($num_files<$limit) $limit=$num_files;
		if($direction==0) echo "<b>Latest $limit <span style=\"color: green\">uploaded</span> files</b>\n";
		else echo "<b>Latest $limit <span style=\"color: red\">downloaded</span> files</b>\n";
		echo "<div class=\"box-border\">\n";
		echo "<div class=\"box-text\">\n";
	
		while($row_latest=mysql_fetch_array($res_latest)){
			echo date('Y.m.d H:i:s',$row_latest[0])." : $row_latest[file] : $row_latest[bytes] : $row_latest[user] : $row_latest[host]<br />\n";
		}
		echo "</div>\n</div>\n";
	}
}

function pop_files($limit=10){
	/* Writes the most popular files (downloaded, there is no point in showing upload :-) */

	$res_pop=mysql_query("select COUNT(file) as cnt,file from log where direction=1 GROUP by file order by cnt desc limit $limit") or die(mysql_error());
	echo "<b>$limit most popular files</b>\n";
	echo "<div class=\"box-border\">\n";
	echo "<div class=\"box-text\">\n";
	$pop_files=array();
	for($i=0;$i<$limit;$i++){
		$row_pop=mysql_fetch_array($res_pop);
		$pop_files[$i][0]=$row_pop[0]; // 0 = number
		$pop_files[$i][1]=$row_pop[1]; // 1 = name
	}
	rsort($pop_files);
	for($i=0;$i<$limit;$i++){
		echo "".$pop_files[$i][1]." - <span style=\"color: red\">downloaded</span>: ".$pop_files[$i][0]." times<br />\n";
	}
	echo "</div>\n</div>\n";
}

function list_log($index=0,$step=250){
	/* List all log data if not $limit is set */
	$query_string="select UNIX_TIMESTAMP(time),direction,file,bytes,user,host from log order by time desc limit $index,$step";

	$res_total=mysql_query("select COUNT(id) as total from log") or die(mysql_error());
	$row_total=mysql_fetch_array($res_total);
	$last_index=floor(($row_total[total]/$step))*$step;

	$res_list=mysql_query($query_string) or die(mysql_error());
	$num_rows=mysql_num_rows($res_list);
	
	if($index==0){
		echo "&lt; &nbsp; &lt;&lt;";
	}else{
		echo "<a href=\"?index=".($index-$step)."&step=$step\">&lt;</a> &nbsp; <a href=\"?index=0&step=$step\">&lt;&lt;</a>"; 
	}
	echo " | ";
	if($num_rows==$step){
		echo "<a href=\"?index=".$last_index."&step=$step\">&gt;&gt;</a> &nbsp; <a href=\"?index=".($index+$step)."&step=$step\">&gt;</a>";
	}else{
		echo "&gt;&gt; &nbsp; &gt;";
	}
	echo "<br />\n";
        echo "<div class=\"box-border\">\n";
        echo "<div class=\"box-text\">\n";
	while($row_list=mysql_fetch_array($res_list)){
		$dir_text=$row_list[direction] ? '<span style="color: red">download</span>' : '<span style="color: green">upload</span>';
                echo date('Y.m.d H:i:s',$row_list[0])." : $dir_text : $row_list[file] : $row_list[bytes] : $row_list[user] : $row_list[host]<br />\n";
        }
	echo "</div>\n</div>\n";
}



/* ++++++++++++++++++   glftpd.log functions   ++++++++++++++++++++++++++++ */

function read_glftpdlog($GLFTPD_FILE="",$SITE_ROOT=""){
	
	if(strlen($GLFTPD_FILE)<2) $GLFTPD_FILE="/glftpd/ftp-data/logs/glftpd.log";
	if(strlen($SITE_ROOT)<2) $SITE_ROOT="/site";
	
	$glftpd_file=$GLFTPD_FILE;
	$site_root=$SITE_ROOT;
	
	$fd = fopen ($glftpd_file,"r");     // full path to glftpd.log
	if(!$fd){
		echo "<b>Error reading file!</b><br />\n";
		exit;
	}
	$res=mysql_query("delete from online") or die(mysql_error());	// clear out old logentries
	$elements_tmp=array();
	$elements=array();
	$elements2=array();
	while (TRUE) {
		$buffer = fgets($fd, 4096);
		
		$elements_tmp=split(": ",$buffer);	// spilt the string in 2 parts
		$elements=preg_split("/[\s]+/",$elements_tmp[0]);	// spilt the first part by one or more blanks
		
		if($elements[5]=='NEWDIR') $elements2=split(' "',$elements_tmp[1]);	// if the second part is a NEWDIR, then split by ' "'
		else $elements2=preg_split("/[\s]+/",$elements_tmp[1]);		// else spilt the second part  by one or more blanks

		if($elements[0]=='') break;     // not a nice way to do it, but i works ;-)
		
		/* MySQL table: id,time,type,host,user
		   type: 1=LOGIN,2=LOGOUT,3=TIMEOUT
		*/
		if($elements[5]=='LOGIN' or $elements[5]=='LOGOUT' or $elements[5]=='TIMEOUT'){	// the ones we whant
			$timestring=$elements[3]." ".$elements[2]." ". $elements[1]." ". $elements[4];  // create timestring
			$timestring=date('YmdHis',strtotime($timestring));
			$type=0;
			if($elements[5]=='LOGIN') $type=1;
			if($elements[5]=='LOGOUT') $type=2;
			if($elements[5]=='TIMEOUT') $type=3;
			
			$host="";
			if($elements[5]=='LOGIN') $host=preg_replace("/[(,)]+/","",$elements2[1]);	// strip '(' ')'
			
			$user="";
			if($elements[5]=='TIMEOUT') $user=str_replace('"','',$elements2[0]);	// strip '"'
			else $user=str_replace('"','',$elements2[2]);	// strip '"'

			$res=mysql_query("insert into online (time,type,host,user) values('$timestring',$type,'$host','$user')") or die(mysql_error());
		}elseif($elements[5]=='NEWDIR'){
                        $timestring=$elements[3]." ".$elements[2]." ". $elements[1]." ". $elements[4];  // create timestring
                        $timestring=date('YmdHis',strtotime($timestring));
                        $type=4;
			$host=str_replace($site_root,'',str_replace('"','',$elements2[0]));	// I know. $host should be for hostname, but I'll use it for NEWDIRS as well :-)
			$user=str_replace('"','',$elements2[1]);
                        $res=mysql_query("insert into online (time,type,host,user) values('$timestring',$type,'$host','$user')") or die(mysql_error());
		}
	}
	fclose ($fd);
}

function last_login($user){
	$res=mysql_query("select UNIX_TIMESTAMP(time),host from online where user='$user' and type=1 order by time desc limit 1") or die(mysql_error());
	$row=mysql_fetch_array($res);
	return $row;	// returns timestamp [0] and host [1]
}


function last_logout($user){
	$res=mysql_query("select UNIX_TIMESTAMP(time) from online where user='$user' and type=2 order by time desc limit 1") or die(mysql_error());
	$row=mysql_fetch_array($res);
	return $row;	// returns timestamp
}

function last_timeout($user){
	$res=mysql_query("select UNIX_TIMESTAMP(time) from online where user='$user' and type=3 order by time desc limit 1") or die(mysql_error());
	if(mysql_num_rows($res)>0){
		$row=mysql_fetch_array($res);
		return $row;	// returns timestamp
	}else{
		return 0;
	}
}
function new_dirs($user="",$limit=10){
	$query_string="";
	if(strlen($user)<2){
		$query_string="select UNIX_TIMESTAMP(time) as tm,host,user from online where type=4 order by time desc limit $limit";
	}else{
		$query_string="select UNIX_TIMESTAMP(time) as tm,host,user from online where user='$user' and type=4 order by time desc limit $limit";
	}
	$res_newdirs=mysql_query($query_string) or die(mysql_error());
	$num_rows=mysql_num_rows($res_newdirs);
	if($num_rows>0){
		if($num_rows<$limit) $limit=$num_rows;
		echo "<b>Latest $limit directories</b>\n";
		echo "<div class=\"box-border\">\n";
		echo "<div class=\"box-text\">\n";
		while($row_newdir=mysql_fetch_array($res_newdirs)){
			echo date('Y.m.d H:i:s',$row_newdir[tm])." : ".$row_newdir[host]." : ".$row_newdir[user]."<br />\n";
		}
	}
	echo "</div>\n</div>\n";

}

function online($user){
	$login=last_login($user);
	$logout=last_logout($user);
	$timeout=last_timeout($user);
	$status="";

	if(is_online($user)==1){
		$status="<span style=\"color: green\">online</span>\n";
	}else{
		$status="<span style=\"color: red\">offline</span>";
		if(($logout[0]-$timeout[0])>0) $status.=" - logout time: ".date('Y.m.d H:i:s',$logout[0]);
		else $status.=" - logout time: ".date('Y.m.d H:i:s',$timeout[0]);
	}

	echo "User is: $status <br />\n";
	echo "Last login time: " .date('Y.m.d H:i:s',$login[0]) ."<br />\n";
	echo "Last login from: " .$login[1]. "<br />\n";
	
}

function is_online($user){
	$login=last_login($user);
	$logout=last_logout($user);
	$timeout=last_timeout($user);
	$status=0;
	if(($login[0]-$logout[0])>0 and ($login[0]-$timeout[0])>0) $status=1;
	return $status;
}

function list_users(){
	$usr_online=array();
	$usr_offline=array();
	$cnt_online=0;
	$cnt_offline=0;
	$res_usr=mysql_query("select DISTINCT user from online where user!='glftpd' and type!=4 order by user") or die(mysql_error());
	while($row_usr=mysql_fetch_array($res_usr)){
		if(is_online($row_usr[user])==1){
			$usr_online[$cnt_online]=$row_usr[user];
			$cnt_online++;
		}else{
			$usr_offline[$cnt_offline]=$row_usr[user];
			$cnt_offline++;
		}
	}
	echo "<b>Online users</b>:<br />\n";
	if(sizeof($usr_online)==0){
		echo "<div style=\"margin-left: 10px\">None</div>\n";
	}else{
		foreach($usr_online as $val){
			echo "<a style=\"margin-left: 10px\" href=\"index.php?user=$val\">$val</a><br />\n";
		}
	}
	echo "<br />\n";
	echo "<b>Offline users</b>:<br />\n";
	if(sizeof($usr_offline)==0){
		echo "None";
	}else{
		foreach($usr_offline as $val){
			echo "<a style=\"margin-left: 10px\" href=\"index.php?user=$val\">$val</a><br />\n";
		}
	}
	echo "<br />\n";
}


?>
