<?php
require("dbconnect.php");
require("functions.php");

echo "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n";
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head><title>glftpd xferlogDB</title>
<link rel="stylesheet" href="styles.css" type="text/css" />
</head>
<body>
<h1>xferlogDB</h1>
<div style="text-align: right; color: grey">xferlogDB v0.4.3 by Brian Christensen<br /><a href="http://www.jordhulen.dk/xferlogDB">http://jordhulen.dk/xferlogDB</a></div>
<?php
read_glftpdlog($GLFTPD_FILE,$SITE_ROOT);	// ok to read the log here - it's not that big
if($readlog==1) readlog($XFERLOG_FILE,$SITE_ROOT);

$last_updated=lastupdate(); 
echo "<p><a href=\"?readlog=1\">Update xferlogDB (process xferlog file)</a> &nbsp;-&nbsp; last updated: ".date('Y.m.d H:i:s',$last_updated[0])." with: ".$last_updated[1]." log entries</p>\n";


if(isset($user)){
	echo "<a href=\"index.php\">general stats</a> | <a href=\"?index=0\">full log list</a><br />\n";
	echo "<h3>User stats for $user</h3>\n";
	echo "<div class=\"box-border\">\n";
	echo "<div class=\"box-text\">\n";
	online($user);
	$transfer=usertransfer($user);
	echo "<span style=\"color: red\">Downloaded</span>: ".$transfer[1]." MB<br />\n";
	echo "<span style=\"color: green\">Uploaded</span>: ".$transfer[0]." MB<br />\n";
	echo "</div>\n</div>\n";
	echo "<div style=\"clear: both; margin-bottom: 20px;\">\n";
	latest_files(1,$user);
	echo "</div>\n";
	echo "<div style=\"clear: both; margin-bottom: 20px;\">\n";
	latest_files(0,$user);
	echo "</div>\n";
	echo "<div style=\"clear: both; margin-bottom: 20px;\">\n";
	new_dirs($user);
	echo "</div>\n";
}elseif(isset($index)){
	echo "<a href=\"index.php\">general stats</a> | full log list<br />\n";
	echo "<h3>Log list</h3>\n";
	list_log($index);
}else{
	echo "general stats | <a href=\"?index=0\">full log list</a>\n";
	echo "<h3>General stats for ftp server</h3>\n";
	echo "<div style=\"float: left; width: 25%; text-align: left\">\n";
	echo "<div class=\"box-border\">\n";
	echo "<div class=\"box-text\">\n";
	list_users();
	echo "<br />\nClick on username to see user stats<br />\n";
	echo "</div>\n</div>\n</div>\n";
	echo "<div style=\"float: left; width: 75%; text-align: left\">\n";
	echo "<div style=\"float: left; width: 50%; text-align: left\">\n";
	top10bytes(1,5);
	echo "</div>\n";
	echo "<div style=\"float: left; width: 50%; text-align: left\">\n";
	top10bytes(0,5);
	echo "</div>\n";
	echo "<div style=\"float: left; width: 50%; text-align: left\">\n";
	top10files(1,5);
	echo "</div>\n";
	echo "<div style=\"float: left; width: 50%; text-align: left\">\n";
	top10files(0,5);
	echo "</div>\n";
	echo "<div style=\"float: left; width: 100%; text-align: left\">\n";
	pop_files(5);
	echo "</div>\n";
	echo "</div>\n";
	echo "<div style=\"clear: both; margin-bottom: 20px;\">\n";
	latest_files(1);
	echo "</div>\n";
	echo "<div style=\"clear: both; margin-bottom: 20px;\">\n";
	latest_files(0);
	echo "</div>\n";
	echo "<div style=\"clear: both; margin-bottom: 20px;\">\n";
	new_dirs();
	echo "</div>\n";
}


?>
</body>
</html>
